unit _ipDBxControls;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask, DBCtrls, Menus, ExtCtrls, db, DBTables, _ip;

type

     Tip_DBzEdit = class(TEdit)
  private
     FDataLink: TFieldDataLink;
     FCanUpdate: Boolean;
     FOldText: String;
     FNewText: String;
     FSearchArray:string;
     procedure DataChange(Sender: TObject);
     function GetDataField: string;
     procedure SetDataField(const Value: string);
     function GetDataSource: TDataSource;
     procedure SetDataSource(Value: TDataSource);
     procedure DoAction;
     procedure UpdateData(Sender: TObject);
    { Private declarations }
  protected
    { Protected declarations }
    procedure Notification(AComponent: TComponent;
      Operation: TOperation); override;
    procedure Loaded; override;
    procedure KeyPress(var Key: Char); override;
    procedure DoExit; override;
    procedure DoEnter; override;
   public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property DataField: string read GetDataField write SetDataField;
    property DataSource: TDataSource read GetDataSource write SetDataSource;
    property SearchArray: string read FSearchArray write FSearchArray;
  end;

procedure Register;

implementation

//______________________________________________________________________________

procedure Tip_DBzEdit.KeyPress(var Key: Char);
var
    FEditTemp : TCustomForm;
begin

  inherited KeyPress(Key);
  if (Key=#13) and (Text<>FDataLink.Field.Text) then
  begin
    DoAction;

  end;
     {if (Key = #13) then
     begin
        FEditTemp := GetParentForm(Self);
        if(FEditTemp is TCSEZForm) then
        begin
            SendMessage(FEditTemp.Handle, WM_NEXTDLGCTL, 0, 0);
            Key := #0;
        end;
     end;    }
end;

procedure Tip_DBzEdit.DataChange(Sender: TObject);
begin
    if FDataLink.Field <> nil then
    begin
        if FCanUpdate then
        Text:=FDataLink.Field.Text;
    end
    else
    begin
       // FAlignment := taLeftJustify;
       // EditMask := '';
        if csDesigning in ComponentState then
            Text := Name else
            Text := '';
    end;
end;

procedure Tip_DBzEdit.UpdateData(Sender: TObject);
begin
  //ValidateEdit;
  //FDataLink.Field.Text := Text;
end;

constructor Tip_DBzEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Color:=clYellow;
  Font.Style:=Font.Style+[fsBold];
  FDataLink := TFieldDataLink.Create;
  FDataLink.Control := Self;
  FDataLink.OnDataChange := DataChange;
  FCanUpdate:=True;
  FDataLink.OnEditingChange := DataChange;
  FDataLink.OnUpdateData := UpdateData;
end;

destructor Tip_DBzEdit.Destroy;
begin
  FDataLink.Free;
  FDataLink := nil;
  inherited Destroy;
end;

procedure Tip_DBzEdit.Loaded;
begin
  inherited Loaded;
    if (csDesigning in ComponentState) then DataChange(Self);
end;

procedure Tip_DBzEdit.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) and (FDataLink <> nil) and
    (AComponent = DataSource) then DataSource := nil;
end;

function Tip_DBzEdit.GetDataSource: TDataSource;
begin
  Result := FDataLink.DataSource;
end;

procedure Tip_DBzEdit.SetDataSource(Value: TDataSource);
begin
  FDataLink.DataSource := Value;
   if Value <> nil then Value.FreeNotification(Self);
end;

function Tip_DBzEdit.GetDataField: string;
begin
  Result := FDataLink.FieldName;
end;

procedure Tip_DBzEdit.SetDataField(const Value: string);
begin
  FDataLink.FieldName := Value;
end;

procedure Tip_DBzEdit.DoAction;
var
    i, Code:integer;
    s:string;
begin
//    FStoredText:=Text;
    if not (FDataLink.Dataset as TTable).FindKey([Text]) then
    begin
        if MessageDlg('Create new record with text '+Text+' ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
        begin
            if (FDataLink.Dataset as TTable).FindKey([Text]) then exit;
            FCanUpdate:=False;
            FDataLink.Dataset.Append;
            FDataLink.Field.Text:=Text;
            FDataLink.Dataset.Post;
            FCanUpdate:=True;
            DataChange(Self)
        end
        else
        begin
            FOldText:=FDataLink.Field.Text;
            FNewText:=Text;
            if MessageDlg('Change '+FDataLink.Field.Text+' to '+Text+' ?', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
            //if ipDialogDaNe('Promjeni ifru '+FDataLink.Field.Text+' u '+Text+' ?') then
            begin
                if (FDataLink.Dataset as TTable).FindKey([Text]) then
                begin
                    Beep;
                    ShowMessage('Allready exists!');
                    exit;
                end
                else
                begin
                     (FDataLink.Dataset as TTable).FindKey([FOldText]);
                    FCanUpdate:=False;
                    FDataLink.Dataset.Edit;
                    FDataLink.Field.Text:=FNewText;
                    FDataLink.Dataset.Post;
                    FCanUpdate:=True;
                    DataChange(Self)
                end;
            end;
        end;
    end;
end;

procedure Tip_DBzEdit.DoExit;
begin
    DataChange(self);
    inherited DoExit;
end;

procedure Tip_DBzEdit.DoEnter;
begin
    if (FDatalink.Dataset.State=dsInsert) or (FDatalink.Dataset.State=dsEdit) then
        FDatalink.Dataset.Post;
    inherited DoExit;
end;
//______________________________________________________________________________



procedure Register;
begin
  RegisterComponents('_InfoPlus', [Tip_DBzEdit]);
end;

end.
